#include "ruby-spml.h"

#ifdef IFORT
extern struct farray* wa_interpolate_module_mp_a_interpolate_array00_wa_(struct farray*, struct farray*, double*, double*);
#endif
#ifdef GFORTRAN
extern struct farray* __wa_interpolate_module_MOD_a_interpolate_array00_wa(struct farray*, struct farray*, double*, double*);
#endif


static VALUE
rbspml_a_Interpolate_array00_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_data, alon, alat, out;
  struct farray* cwa_data;
  double calon;
  double calat;
  struct farray* cout;

  rb_scan_args(argc, argv, "30", &wa_data, &alon, &alat);
  wa_data = na_cast_object(wa_data, NA_DFLOAT);
  cwa_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_data)->shape[i];
    offset += j;
  }
  cwa_data->offset = -offset;
}
#endif
#if defined IFORT
  cwa_data->vsize = sizeof(double);
{
  long type = 10;
  cwa_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_data->rank = 2;
#elif defined GFORTRAN
{
  cwa_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_data->total = NA_STRUCT(wa_data)->total;
  cwa_data->total_byte = cwa_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_data)->shape[i];
    fs = (struct fshape*)(cwa_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_data->array = NA_PTR_TYPE(wa_data, void*);
  calon = NUM2DBL(alon);
  calat = NUM2DBL(alat);
{
  int shape[1];
  shape[0] = (NA_STRUCT(wa_data)->shape[2]);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_interpolate_module_mp_a_interpolate_array00_wa_(cout, cwa_data, &calon, &calat);
#elif defined GFORTRAN
  __wa_interpolate_module_MOD_a_interpolate_array00_wa(cout, cwa_data, &calon, &calat);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "a_Interpolate_array00_wa is not supported for FFC comilar");
#endif

  free(cwa_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_wa_interpolate_module(VALUE mSPML)
{
  VALUE mWA_INTERPOLATE;

  mWA_INTERPOLATE = rb_define_module_under(mSPML, "WA_INTERPOLATE");

  rb_define_module_function(mWA_INTERPOLATE, "a_Interpolate_array00_wa", rbspml_a_Interpolate_array00_wa, -1);
  rb_define_method(mWA_INTERPOLATE, "a_Interpolate_array00_wa", rbspml_a_Interpolate_array00_wa, -1);
}
